## dunedynasty 1.6.4%2Bds

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_BINDIR=games -DDUNE_DATA_DIR=/usr/share/games/dune2

execute_after_dh_auto_install:
	rm -rf debian/dunedynasty/usr/share/games/dune2/data

execute_after_dh_installdocs:
	mv debian/dunedynasty/usr/share/games/dune2/music debian/dunedynasty/usr/share/doc/dunedynasty/music
