=== debian/changelog ===
dunedynasty (1.6.4+ds-1) unstable; urgency=low

  * Initial release (Closes: #1126954)

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 04 Feb 2026 10:07:39 +0100
