=== debian/control ===
Source: dunedynasty
Section: contrib/games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13),
               cmake,
               liballegro-acodec5-dev,
               liballegro-audio5-dev,
               liballegro-image5-dev,
               libenet-dev,
               libfluidsynth-dev,
               libmad0-dev
Standards-Version: 4.7.3
Homepage: https://github.com/gameflorist/dunedynasty
Vcs-Browser: https://salsa.debian.org/games-team/dunedynasty
Vcs-Git: https://salsa.debian.org/games-team/dunedynasty.git

Package: dunedynasty
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: dune2-v17-eu-data | game-data-packager
Description: Dune II game engine reimplementation
 Lead one of three interplanetary houses, Atreides, Harkonnen
 or Ordos, in an attempt to harvest the largest amount of spice
 from the sand dunes. Exchange your spice stockpiles for credits
 through refinement and build an army capable of thwarting attempts
 of the other houses to stop your harvesting!
 .
 Dune Dynasty is an reimplementation of the classic real-time strategy game
 Dune II by Westwood Studios. It builds upon the original game engine
 as reverse-engineered by the OpenDUNE project and adds many enhancements,
 modernizations and new features.
 .
 The original Dune II game data files are required to run Dune Dynasty.
 You can install them by using the game-data-packager tool.
