=== debian/watch ===
Version: 5
Template: Github
Owner: gameflorist
Project: dunedynasty
Dversion-Mangle: auto
Repack: yes
Repacksuffix: +ds
Compression: xz
